/* ************************************************************************** */
/*                                       _____           _                    */
/*  libp7/internals/byteswap.h          |_   _|__  _   _| |__   ___ _   _     */
/*  | Project: libp7                      | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2017/01/21 12:06:11                               |___/     */
/*                                                                            */
/* ************************************************************************** */
#ifndef LIBP7_INTERNALS_BYTESWAP_H
# define LIBP7_INTERNALS_BYTESWAP_H
# if (defined(_WIN16) || defined(_WIN32) || defined(_WIN64)) \
	&& !defined(__WINDOWS__)
#  define __WINDOWS__
# endif

# include <libp7/config.h>
# include <stdint.h>

# if defined(__linux__) || defined(__CYGWIN__)
#  include <byteswap.h>

# elif defined(__WINDOWS__)
#  include <stdlib.h>
#  define __p7_bswap_16(B) (_byteswap_ushort(B))
#  define __p7_bswap_32(B) (_byteswap_ulong(B))
#  define __p7_bswap_64(B) (_byteswap_uint64(B))

# else
#  error "Unsupported platform."
# endif

#endif /* LIBP7_INTERNALS_BYTESWAP_H */
