/* ************************************************************************** */
/*                                       _____           _                    */
/*  libp7/internals/sleep.h             |_   _|__  _   _| |__   ___ _   _     */
/*  | Project: libp7                      | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2017/01/19 12:34:15                               |___/     */
/*                                                                            */
/* ************************************************************************** */
#ifndef LIBP7_INTERNALS_SLEEP_H
# define LIBP7_INTERNALS_SLEEP_H

/* MS-Windows stuff */
# if (defined(_WIN16) || defined(_WIN32) || defined(_WIN64)) \
	&& !defined(__WINDOWS__)
#  define __WINDOWS__
# endif

/* the real thing */
# if defined(__WINDOWS__)
#  include <windows.h>
#  define sleep(N) Sleep((N) * 1000)
# elif defined(__linux__)
#  include <unistd.h>
# else
/* active waiting;
 * this is cross-platform but inaccurate and power-consuming. Yay! */
#  define sleep(N) \
	for (int i = (N) * 100000; i; i--)
# endif

#endif /* LIBP7_INTERNALS_SLEEP_H */
