/* ************************************************************************** */
/*                                       _____           _                    */
/*  utils/filebuffer.c                  |_   _|__  _   _| |__   ___ _   _     */
/*  | Project: libp7                      | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2017/02/05 18:34:15                               |___/     */
/*                                                                            */
/* ************************************************************************** */
#include <libp7/internals.h>
#ifndef P7_DISABLED_FILE

/**
 *	p7_filebuffer_read:
 *	Read from a FILE*. P7_Buffer callback.
 *
 *	TODO: manage errors.
 *
 *	@arg	vcookie		the cookie (uncasted).
 *	@arg	dest		the destination buffer.
 *	@arg	size		the size to read.
 *	@return				the error code (0 if ok).
 */

int p7_filebuffer_read(void *vcookie, unsigned char *dest, size_t size)
{
	FILE *f = (FILE*)vcookie;
	fread(dest, size, 1, f);
	return (0);
}

/**
 *	p7_filebuffer_write:
 *	Write to a FILE*. P7_Buffer callback.
 *
 *	@arg	vcookie		the cookie (uncasted).
 *	@arg	dest		the destination buffer.
 *	@arg	size		the size to read.
 *	@return				the error code (0 if ok).
 */

int p7_filebuffer_write(void *vcookie, const unsigned char *data, size_t size)
{
	FILE *f = (FILE*)vcookie;
	fwrite(data, size, 1, f);
	return (0);
}

#endif
