/* ************************************************************************** */
/*                                       _____           _                    */
/*  utils/validate.c                    |_   _|__  _   _| |__   ___ _   _     */
/*  | Project: libp7                      | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2017/01/04 15:01:48                               |___/     */
/*                                                                            */
/* ************************************************************************** */
#include <libp7/internals.h>
#include <ctype.h>

/**
 *	p7_validate_filename:
 *	Validate a filename.
 *
 *	@arg	filename		the filename to validate
 *	@return					if it is validated
 */

int p7_validate_filename(const char *filename)
{
	for (size_t n = 0; filename[n]; n++)
		if (n >= 12 || !isascii(filename[n])) return (0);
	return (1);
}

/**
 *	p7_validate_dirname:
 *	Validate a directory name.
 *
 *	@arg	dirname			the directory name to validate
 *	@return					if it is validated
 */

int p7_validate_dirname(const char *dirname)
{
	for (size_t n = 0; dirname[n]; n++)
		if (n >= 9 || !isascii(dirname[n])) return (0);
	return (1);
}
